FIX::SynchronizedApplication Class Reference

This is a special implementation of the Application interface that takes in another Application interface and synchronizes all of its callbacks. More...

`#include <Application.h>`

Inheritance diagram for FIX::SynchronizedApplication:
[legend]
Collaboration diagram for FIX::SynchronizedApplication:
[legend]

## Public Member Functions

| SynchronizedApplication (Application &app)
void | onCreate (const SessionID &sessionID)
| Notification of a session begin created. More...
void | onLogon (const SessionID &sessionID)
| Notification of a session successfully logging on. More...
void | onLogout (const SessionID &sessionID)
| Notification of a session logging off or disconnecting. More...
void | toAdmin (Message &message, const SessionID &sessionID)
| Notification of admin message being sent to target. More...
void | toApp (Message &message, const SessionID &sessionID) throw ( DoNotSend )
| Notification of app message being sent to target. More...
void | fromAdmin (const Message &message, const SessionID &sessionID) throw ( FieldNotFound, IncorrectDataFormat, IncorrectTagValue, RejectLogon )
| Notification of admin message being received from target. More...
void | fromApp (const Message &message, const SessionID &sessionID) throw ( FieldNotFound, IncorrectDataFormat, IncorrectTagValue, UnsupportedMessageType )
| Notification of app message being received from target. More...
Application & | app ()
Public Member Functions inherited from FIX::Application
virtual | ~Application ()

## Public Attributes

Mutex | m_mutex
Application & | m_app

## Detailed Description

This is a special implementation of the Application interface that takes in another Application interface and synchronizes all of its callbacks.

This will guarantee that only one thread will access the applications code at a time.

This class is a great convenience for writing applications where you don't want to worry about synchronization. There is of course a tradeoff in that you may be synchronizing more than you need to. There is also a very minor performance penalty due to the extra virtual table lookup.

Definition at line 93 of file Application.h.

## Constructor & Destructor Documentation

## SynchronizedApplication()

FIX::SynchronizedApplication::SynchronizedApplication | ( | Application & | app | ) |

inline

Definition at line 96 of file Application.h.

{ Locker l( m_mutex ); app().fromApp( message, sessionID ); }

## Member Function Documentation

## app()

Application& FIX::SynchronizedApplication::app | ( |  | ) |

inline

Definition at line 118 of file Application.h.

{}

## fromAdmin()

void FIX::SynchronizedApplication::fromAdmin | ( | const Message & | ,
|  | const SessionID & |
| ) |  |
throw | ( | FieldNotFound,
|  | IncorrectDataFormat,
|  | IncorrectTagValue,
|  | RejectLogon
| ) |  |

inline virtual

Notification of admin message being received from target.

Implements FIX::Application.

Definition at line 109 of file Application.h.

: public Application

## fromApp()

void FIX::SynchronizedApplication::fromApp | ( | const Message & | ,
|  | const SessionID & |
| ) |  |
throw | ( | FieldNotFound,
|  | IncorrectDataFormat,
|  | IncorrectTagValue,
|  | UnsupportedMessageType
| ) |  |

inline virtual

Notification of app message being received from target.

Implements FIX::Application.

Definition at line 112 of file Application.h.

{
void onCreate( const SessionID& ) {}
void onLogon( const SessionID& ) {}

References FIX::Application::onCreate(), FIX::Application::onLogon(), and FIX::Application::onLogout().

## onCreate()

void FIX::SynchronizedApplication::onCreate | ( | const SessionID & |  | ) |

inline virtual

Notification of a session begin created.

Implements FIX::Application.

Definition at line 98 of file Application.h.

{ return m_app; }

## onLogon()

void FIX::SynchronizedApplication::onLogon | ( | const SessionID & |  | ) |

inline virtual

Notification of a session successfully logging on.

Implements FIX::Application.

Definition at line 100 of file Application.h.

{ return m_app; }

## onLogout()

void FIX::SynchronizedApplication::onLogout | ( | const SessionID & |  | ) |

inline virtual

Notification of a session logging off or disconnecting.

Implements FIX::Application.

Definition at line 102 of file Application.h.

: public Application

## toAdmin()

void FIX::SynchronizedApplication::toAdmin | ( | Message & | ,
|  | const SessionID & |
| ) |  |

inline virtual

Notification of admin message being sent to target.

Implements FIX::Application.

Definition at line 104 of file Application.h.

: public Application

## toApp()

void FIX::SynchronizedApplication::toApp | ( | Message & | ,
|  | const SessionID & |
| ) |  |
throw | ( | DoNotSend
| ) |  |

inline virtual

Notification of app message being sent to target.

Implements FIX::Application.

Definition at line 106 of file Application.h.

: public Application

## Member Data Documentation

## m_app

Application& FIX::SynchronizedApplication::m_app

Definition at line 119 of file Application.h.

## m_mutex

Mutex FIX::SynchronizedApplication::m_mutex

Definition at line 116 of file Application.h.

The documentation for this class was generated from the following file:

- Application.h

FIX::SynchronizedApplication::onCreate
void onCreate(const SessionID &sessionID)
Notification of a session begin created.
Definition: Application.h:98
FIX::SynchronizedApplication::app
Application & app()
Definition: Application.h:118
FIX::SynchronizedApplication::m_mutex
Mutex m_mutex
Definition: Application.h:116
FIX::SynchronizedApplication::onLogon
void onLogon(const SessionID &sessionID)
Notification of a session successfully logging on.
Definition: Application.h:100
FIX::Application::fromApp
virtual void fromApp(const Message &, const SessionID &)=0
Notification of app message being received from target.
FIX::SynchronizedApplication::m_app
Application & m_app
Definition: Application.h:119